//susanoo.fx;

// #pragma comment(linker, "/stack:200000000")
// #pragma GCC optimize("Ofast")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,tune=native")
 

#include "bits/stdc++.h"
using namespace std;


void __print(int x) {cerr << x;}
void __print(long x) {cerr << x;}
void __print(long long x) {cerr << x;}
void __print(unsigned x) {cerr << x;}
void __print(unsigned long x) {cerr << x;}
void __print(unsigned long long x) {cerr << x;}
void __print(float x) {cerr << x;}
void __print(double x) {cerr << x;}
void __print(long double x) {cerr << x;}
void __print(char x) {cerr << '\'' << x << '\'';}
void __print(const char *x) {cerr << '\"' << x << '\"';}
void __print(const string &x) {cerr << '\"' << x << '\"';}
void __print(bool x) {cerr << (x ? "true" : "false");}
template<typename T, typename V>
void __print(const pair<T, V> &x) {cerr << '{'; __print(x.first); cerr << ','; __print(x.second); cerr << '}';}
template<typename T>
void __print(const T &x) {int f = 0; cerr << '{'; for (auto &i: x) cerr << (f++ ? "," : ""), __print(i); cerr << "}";}
void _print() {cerr << "]\n";}
template <typename T, typename... V>
void _print(T t, V... v) {__print(t); if (sizeof...(v)) cerr << ", "; _print(v...);}
#ifndef ONLINE_JUDGE
#define dbg(x...) cerr << "[" << #x << "] = ["; _print(x)
#else
#define dbg(x...)
#endif


#define SpeedForce          ios_base::sync_with_stdio(0);cin.tie(0);
#define ff                  first
#define ss                  second
#define ll                  long long
#define ull                 unsigned long long
#define pb                  push_back
#define in                  insert
#define vll                 vector<ll>
#define sll                 set<ll>
#define skip                continue
#define dnl                 nl << nl
#define sz(x)               (int)x.size()
#define all(x)              (x).begin(),(x).end()
#define rall(x)             (x).rbegin(),(x).rend()
#define out(v)              for(auto& i : v) cout << i << ' ';


const int N = 1e6 + 12 ;
const long long modd = 1e9 + 7;
const int inf = INT_MAX;
const string alf = "abcdefghijklmnopqrstuvwxyz";
const char nl = '\n' ;
const short dRow[] = {1 , 0 , -1 , 0} ;
const short dCol[] = {0 , 1 , 0 , -1} ;

#define int ll
                                    
void setFO(string s){
    if(s.empty()) return ;
    freopen((s + ".in").c_str(), "r", stdin);
    freopen((s + ".out").c_str(), "w", stdout);    
}

double r , ans[N] , w[N];
int x[N] , a[N];
pair <int , double > pr[N];
vector <pair <int , int > > v;

long double binp(long double a , ll n){
	long double res = 1;
	while (n){
		if (n % 2 == 1){
			res *= a;
		}
		a *= a;
		n >>= 1;
	}
	return res;
}

void solve(){
    #define test
    int n , q;
    cin >> n >> q;
    cin >> r;
    ans[0] = 0;
    int mx = 0 , mn = INT_MAX;
    for(int i = 1; i <= n; i ++){
    	cin >> a[i] >> w[i];
    	pr[i] = {a[i] , w[i]};
    	mx = max(mx , a[i]);
    	mn = min(mn , a[i]);
    }
    pr[0] = {0 , 0};
    sort(pr + 1, pr + 1 + n);
    for(int i = 0; i <= n; i ++){
    	if (i >= 1){
    		v.pb({pr[i - 1].ff , pr[i].ff});
    	}
    	ans[pr[i].ff] = ans[pr[i - 1].ff] * binp(1 - r , pr[i].ff - pr[i - 1].ff) + (r * pr[i].ss);
    }
    // cout << ans[3] * binp(1 - r , (int)1e9 - 3);
    for(int i = 1; i <= q; i ++){
    	int x;
    	// dbg(i , r);
    	cin >> x;
    	if (x > mx){
    		cout << fixed << setprecision(10) << ans[mx] * (binp(1 - r , x - mx) / binp(10 , x - mx))<< " ";
    		continue;
    	}
    	if (x < mn){
    		cout << 0 << " ";
    		continue;
    	}
    	if (ans[x] > 0){
    		cout <<fixed << setprecision(10) << ans[x] << " ";
    		continue;
    	}
    	int l = -1 , rr = v.size() + 1;
    	while (rr - l > 1){
    		int mid = (l + rr) / 2;
    		if (v[mid].ff > x){
    			rr = mid;
    			// dbg('a' , v[mid].ff);
    		}
    		else if (v[mid].ss < x){
    			l = mid;
    			// dbg('f' , v[mid].ss);
    		}
    		else {
    			// cout << ans[v[mid].ff] << " " << binp(1 - r , x - v[mid].ff) << endl;
    			cout <<fixed << setprecision(10) << ans[v[mid].ff] * (binp(1 - r , x - v[mid].ff) / binp(10 , x - v[mid].ff) )<< " ";
    			break;
    		}
    	}
    }
}   


signed main(){
    SpeedForce;
    // setFO("");
    //precalc();
    int T = 1 ;
    int tt = 1;
    #ifdef tests
        cin >> T ;
    #endif
        while(T--){
            // cout << "Case " << tt << ": " << nl;
            solve() ;
            tt ++;
        }
    return 0 ;
}

// ctrl + alt + d for run in cmd